package cz.uhk.pavolpodstreleny.schoolproject.custom_views

import android.content.Context
import android.support.design.widget.TextInputEditText
import android.support.design.widget.TextInputLayout
import android.text.Editable
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.LinearLayout
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.custom_views.view_model.EditableTextModel

/**
 * Created by pavol.podstreleny on 11.01.2018.
 */
class CustomTextInput : LinearLayout {

    var MINIMUM_LENGHT = 2
    var hintTextView: TextView
    var textInputEditText: TextInputEditText
    var textInputLayout: TextInputLayout

    constructor(context: Context) : this(context, null)
    constructor(context: Context, attrs: AttributeSet?) : this(context, attrs, 0)
    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr)

    init {
        val view = LayoutInflater.from(context).inflate(getLayoutResource(), this, true)
        hintTextView = view.findViewById(R.id.customTextView)
        textInputEditText = view.findViewById(R.id.customEditText)
        textInputLayout = view.findViewById(R.id.customInputLayout)
    }

    private fun getLayoutResource(): Int {
        return R.layout.view_custom_text_input
    }

    fun clearEditData() {
        textInputEditText.text = Editable.Factory.getInstance().newEditable("")
    }

    fun setUpModel(data: EditableTextModel) {
        hintTextView.text = data.textHint
        textInputEditText.text = Editable.Factory.getInstance().newEditable(data.editTextValue)
        textInputLayout.hint = data.hints
    }

    fun isModelValid(): Boolean {
        if (textInputEditText.text.toString().trim().length >= MINIMUM_LENGHT) {
            return true
        }
        return false
    }

    fun getTextInputData(): String {
        return textInputEditText.editableText.toString().trim()
    }


}