package cz.uhk.pavolpodstreleny.schoolproject.custom_views

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.LinearLayout
import android.widget.Spinner
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.custom_views.view_model.EditableTextModel

/**
 * Created by pavol.podstreleny on 11.01.2018.
 */
class SelectableSpinner : LinearLayout {

    var textView: TextView
    var spinner: Spinner

    constructor(context: Context) : this(context, null)
    constructor(context: Context, attrs: AttributeSet?) : this(context, attrs, 0)
    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr)

    init {
        val view = LayoutInflater.from(context).inflate(getLayoutResource(), this, true)
        textView = view.findViewById(R.id.selectableDescribtion)
        spinner = view.findViewById(R.id.selectableSpinner)
    }

    private fun getLayoutResource(): Int {
        return R.layout.view_custom_selectable_spinner
    }

    fun setUpModel(data: EditableTextModel) {
        textView.text = data.hints
    }

}