package cz.uhk.pavolpodstreleny.schoolproject.data

import android.arch.lifecycle.LiveData
import android.util.Log
import com.google.firebase.database.*

/**
 * Created by pavol.podstreleny on 23.12.2017.
 */
class FirebaseQueryLiveData : LiveData<DataSnapshot> {

    private val TAG = "FirebaseQueryLiveData"
    private val mType: QueryType? = null
    private val mQuery: Query
    private val mValueEventListener = FirebaseValueEventListener()

    constructor(query: Query) {
        mQuery = query
    }

    constructor(databaseReference: DatabaseReference) {
        mQuery = databaseReference
    }

    override fun onActive() {
        super.onActive()
        mQuery.addValueEventListener(mValueEventListener)
    }

    override fun onInactive() {
        super.onInactive()
        mQuery.removeEventListener(mValueEventListener)
    }

    private inner class FirebaseValueEventListener : ValueEventListener {

        override fun onCancelled(error: DatabaseError?) {
            Log.e(TAG, "Problem with loading data from database: onCancelled method called!! message: ${error?.message}")
        }

        override fun onDataChange(data: DataSnapshot?) {
            value = data
        }
    }
}