package cz.uhk.pavolpodstreleny.schoolproject.data.repositories

import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.DatabaseContract
import cz.uhk.pavolpodstreleny.schoolproject.data.FirebaseResult

/**
 * Created by pavol.podstreleny on 13.01.2018.
 */
class GroupAdminRepository : AdminRepository() {

    suspend fun deleteGroup(groupID: String): FirebaseResult {
        return if (deleteData(DatabaseContract.TABLE_GROUPS_NAME, groupID)) {
            FirebaseResult(true, R.string.group_admin_page_group_deleted)
        } else {
            FirebaseResult(false, R.string.group_admin_page_group_deleted_error)
        }
    }

    suspend fun addGroup(describtion: String, topicID: String?): FirebaseResult {
        if (topicID == null) return FirebaseResult(false, R.string.group_admin_page_group_added_error)

        val map = HashMap<String, Any>()
        map.put(DatabaseContract.TABLE_GROUPS_DESCRIPTION, describtion)
        map.put(DatabaseContract.TABLE_GROUPS_TOPIC, topicID)

        return if (addData(DatabaseContract.TABLE_GROUPS_NAME, map)) {
            FirebaseResult(true, R.string.group_admin_page_group_added)
        } else {
            FirebaseResult(false, R.string.group_admin_page_group_added_error)
        }
    }

    suspend fun editGroup(topicID: String?,groupID: String?, description: String): FirebaseResult {
        if(topicID == null || groupID == null) return FirebaseResult(false, R.string.group_admin_page_group_updated_error)
        val map = HashMap<String,Any>()
        map.put(DatabaseContract.TABLE_GROUPS_TOPIC,topicID)
        map.put(DatabaseContract.TABLE_GROUPS_DESCRIPTION,description)
        return if(editData(DatabaseContract.TABLE_GROUPS_NAME,groupID,map)){
            FirebaseResult(false, R.string.group_admin_page_group_updated)
        }else{
            FirebaseResult(false, R.string.group_admin_page_group_updated_error)
        }
    }

}