package cz.uhk.pavolpodstreleny.schoolproject.receivers

import android.arch.lifecycle.Lifecycle
import android.arch.lifecycle.LifecycleObserver
import android.arch.lifecycle.LifecycleOwner
import android.arch.lifecycle.OnLifecycleEvent
import android.content.Context
import android.content.IntentFilter

/**
 * Created by pavol.podstreleny on 19.03.2018.
 */
class ConnectionObserver : LifecycleObserver {

    private val filter = "android.net.conn.CONNECTIVITY_CHANGE"

    private val receiver: ConnectionReceiver
    private val lifecycleOwner: LifecycleOwner
    private val context: Context

    constructor(receiver: ConnectionReceiver, lifecycleOwner: LifecycleOwner, context: Context) {
        this.receiver = receiver
        this.lifecycleOwner = lifecycleOwner
        this.context = context
        lifecycleOwner.lifecycle.addObserver(this)
    }

    @OnLifecycleEvent(Lifecycle.Event.ON_RESUME)
    fun start() {
        lifecycleOwner.lifecycle.addObserver(this)
        context.registerReceiver(receiver, IntentFilter(filter))
    }

    @OnLifecycleEvent(Lifecycle.Event.ON_PAUSE)
    fun stop() {
        context.unregisterReceiver(receiver)
        lifecycleOwner.lifecycle.removeObserver(this)
    }

}