package cz.uhk.pavolpodstreleny.schoolproject.receivers

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.net.ConnectivityManager
import android.view.View


/**
 * Created by pavol.podstreleny on 19.03.2018.
 */

class ConnectionReceiver : BroadcastReceiver {

    private val mView: View

    constructor(view: View) {
        this.mView = view
    }

    override fun onReceive(context: Context?, intent: Intent?) {
        val connectivityManager = context?.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager

        if (connectivityManager.activeNetworkInfo != null && connectivityManager.activeNetworkInfo.isConnected) {
            mView.visibility = View.GONE
        } else {
            mView.visibility = View.VISIBLE
        }
    }

    fun isNetworkAvailable(context: Context?): Boolean {
        val connectivityManager = context?.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
        return connectivityManager.activeNetworkInfo != null && connectivityManager.activeNetworkInfo.isConnected
    }
}