package cz.uhk.pavolpodstreleny.schoolproject.screens.admin

import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import android.view.MenuItem
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.receivers.ConnectionObserver
import cz.uhk.pavolpodstreleny.schoolproject.receivers.ConnectionReceiver
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.category.CategoryAdminActivity
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.exercise.ExerciseAdminActivity
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.groups.GroupAdminActivity
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.task.TaskAdminActivity
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.topic.TopicAdminActivity
import kotlinx.android.synthetic.main.activity_admin.*
import kotlinx.android.synthetic.main.view_app_bar.*
import kotlinx.android.synthetic.main.view_no_network_connectino.*

/**
 * Created by pavol.podstreleny on 07.01.2018.
 */
class AdminActivity : AppCompatActivity() {

    var connectionObserver: ConnectionObserver? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_admin)
        setSupportActionBar(toolbar)
        supportActionBar?.title = resources.getString(R.string.admin_page_title)
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        connectionObserver = ConnectionObserver(ConnectionReceiver(noInternet),this,this)

        categoryAdmin.setOnClickListener {
            val intent = Intent(this,CategoryAdminActivity::class.java)
            startActivity(intent)
        }

        topicAdmin.setOnClickListener{
            val intent = Intent(this, TopicAdminActivity::class.java)
            startActivity(intent)
        }

        groupAdmin.setOnClickListener {
            val intent = Intent(this, GroupAdminActivity::class.java)
            startActivity(intent)
        }

        exerciseAdmin.setOnClickListener {
            val intent = Intent(this,ExerciseAdminActivity::class.java)
            startActivity(intent)
        }

        taskAdmin.setOnClickListener {
            val intent = Intent(this,TaskAdminActivity::class.java)
            startActivity(intent)
        }

    }

    override fun onResume() {
        super.onResume()
        connectionObserver?.start()
    }

    override fun onOptionsItemSelected(item: MenuItem?): Boolean {
        when (item?.getItemId()) {
            android.R.id.home -> {
                finish()
                return true
            }
        }
        return super.onOptionsItemSelected(item)
    }
}