package cz.uhk.pavolpodstreleny.schoolproject.screens.admin;

import android.content.Context;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;

import cz.uhk.pavolpodstreleny.schoolproject.R;
import cz.uhk.pavolpodstreleny.schoolproject.model.Selectable;

/**
 * Created by pavol.podstreleny on 09.01.2018.
 */

public class DefaultSpinnerAdapter extends ArrayAdapter<Selectable> {

    private ArrayList<Selectable> data;

    public DefaultSpinnerAdapter(Context context, ArrayList<Selectable> data){
        super(context,0,data);
        this.data = data;
    }

    @Override
    public View getDropDownView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        if(convertView == null){
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.view_simple_spinner_open,parent,false);
        }

        Selectable item = data.get(position);
        TextView textView = convertView.findViewById(R.id.spinner);
        textView.setText(item.getName());

        return convertView;
    }

    @NonNull
    @Override
    public View getView(int position, @Nullable View convertView, @NonNull ViewGroup parent) {
        if(convertView == null){
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.view_simple_spinner_open,parent,false);
        }

        Selectable item = data.get(position);
        TextView textView = convertView.findViewById(R.id.spinner);
        textView.setText(item.getName());

        return convertView;
    }

    public void clearData(){
        if(this.data != null){
            data.clear();
            notifyDataSetChanged();
        }
    }

    public Selectable getActualitem(int position){
        return data.get(position);
    }

    public void swapData(ArrayList<Selectable> selectables){
        if (selectables != null) {
            this.data = selectables;
            notifyDataSetChanged();
        }
    }

    public ArrayList<Selectable> getData(){
        return data;
    }

    @Override
    public int getCount() {
        return data.size();
    }
}
