package cz.uhk.pavolpodstreleny.schoolproject.screens.admin.category

import android.net.Uri
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.Action
import cz.uhk.pavolpodstreleny.schoolproject.model.Category

/**
 * Created by pavol.podstreleny on 07.01.2018.
 */
class CategoryAdminAdapter : RecyclerView.Adapter<CategoryAdminAdapter.BasicViewHolder> {

    var data: List<Category>? = null
    var listener: OnCategoryClickListener

    constructor(listener: OnCategoryClickListener) {
        this.listener = listener

    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_category_admin, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: ArrayList<Category>) {
        this.data = data
        notifyDataSetChanged()
    }

    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val imageViewEdit: ImageView
        private val imageViewDelete: ImageView
        private val textView: TextView

        constructor(view: View) : super(view) {
            this.textView = view.findViewById(R.id.defaultText)
            this.imageViewEdit = view.findViewById(R.id.editImage)
            this.imageViewDelete = view.findViewById(R.id.deleteImage)

            imageViewEdit.setOnClickListener {
                val category = data?.get(adapterPosition)
                if (category != null) {
                    val uri = Uri.parse(category.photoURL)
                    listener.onClick(category.categoryKey, uri, Action.EDIT, category.description)
                }
            }

            imageViewDelete.setOnClickListener {
                val category = data?.get(adapterPosition)
                if (category != null) {
                    val uri = Uri.parse(category.photoURL)
                    listener.onClick(category.categoryKey, uri, Action.DELETE, category.description)
                }
            }

        }

        fun bind(position: Int) {
            val category = data?.get(position)
            if (category != null) {
                textView.text = category.description
            }
        }


    }

    interface OnCategoryClickListener {
        fun onClick(categoryKey: String, imageName: Uri, action: Action, categoryName: String)
    }

}