package cz.uhk.pavolpodstreleny.schoolproject.screens.admin.exercise

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.Action
import cz.uhk.pavolpodstreleny.schoolproject.model.Exercise

/**
 * Created by pavol.podstreleny on 15.01.2018.
 */
class ExerciseAdminAdapter : RecyclerView.Adapter<ExerciseAdminAdapter.BasicViewHolder> {

    var data: ArrayList<Exercise>? = null
    var listener: OnClickAdminGroupListener

    constructor(listener: OnClickAdminGroupListener) {
        this.listener = listener
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_category_admin, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: ArrayList<Exercise>?) {
        this.data = data
        notifyDataSetChanged()
    }

    fun clearData() {
        if (data != null) {
            data?.clear()
            notifyDataSetChanged()
        }
    }


    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val imageViewEdit: ImageView
        private val imageViewDelete: ImageView
        private val textView: TextView

        constructor(view: View) : super(view) {
            this.textView = view.findViewById(R.id.defaultText)
            this.imageViewEdit = view.findViewById(R.id.editImage)
            this.imageViewDelete = view.findViewById(R.id.deleteImage)

            imageViewEdit.setOnClickListener {
                val exercise = data?.get(adapterPosition)
                if (exercise != null) {
                    listener.onClick(exercise, Action.EDIT)
                }
            }

            imageViewDelete.setOnClickListener {
                val exercise = data?.get(adapterPosition)
                if (exercise != null) {
                    listener.onClick(exercise, Action.DELETE)
                }
            }

        }

        fun bind(position: Int) {
            val topic = data?.get(position)
            if (topic != null) {
                textView.text = topic.description
            }
        }
    }

    interface OnClickAdminGroupListener {
        fun onClick(topic: Exercise, action: Action)
    }
}