package cz.uhk.pavolpodstreleny.schoolproject.screens.admin.task

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.Action
import cz.uhk.pavolpodstreleny.schoolproject.model.Task

/**
 * Created by pavol.podstreleny on 21.01.2018.
 */

class TaskAdminAdapter : RecyclerView.Adapter<TaskAdminAdapter.BasicViewHolder> {

    var data: ArrayList<Task>? = null
    var listener: OnClickAdminTaskListener


    constructor(listener: OnClickAdminTaskListener) {
        this.listener = listener
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_category_admin, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun clearData() {
        if (data != null) {
            data!!.clear()
            notifyDataSetChanged()
        }
    }

    fun swapData(data: ArrayList<Task>?) {
        this.data = data
        notifyDataSetChanged()
    }

    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val imageViewEdit: ImageView
        private val imageViewDelete: ImageView
        private val textView: TextView

        constructor(view: View) : super(view) {
            this.textView = view.findViewById(R.id.defaultText)
            this.imageViewEdit = view.findViewById(R.id.editImage)
            this.imageViewDelete = view.findViewById(R.id.deleteImage)

            imageViewEdit.setOnClickListener {
                val task = data?.get(adapterPosition)
                if (task != null) {
                    listener.onClick(task, Action.EDIT)
                }
            }

            imageViewDelete.setOnClickListener {
                val task = data?.get(adapterPosition)
                if (task != null) {
                    listener.onClick(task, Action.DELETE)
                }
            }

        }

        fun bind(position: Int) {
            val task = data?.get(position)
            if (task != null) {
                textView.text = task.description
            }
        }
    }

    interface OnClickAdminTaskListener {
        fun onClick(task: Task, action: Action)
    }
}