package cz.uhk.pavolpodstreleny.schoolproject.screens.admin.task.task_add

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.CheckBox
import android.widget.ImageView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.TaskOption

/**
 * Created by pavol.podstreleny on 22.01.2018.
 */
class TaskOptionAdapter : RecyclerView.Adapter<TaskOptionAdapter.BasicViewHolder>() {

    var data: ArrayList<TaskOption> = arrayListOf()

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_task_options, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        return data.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun addData(data: TaskOption) {
        this.data.add(data)
        notifyDataSetChanged()
    }

    fun getStringOptions(): HashMap<String, Boolean> {
        val newData = HashMap<String, Boolean>()
        data.forEach { t: TaskOption? ->
            if (t != null) {
                newData.put(t.description.toString(), t.isChecked)
            }
        }
        return newData
    }


    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val imageViewDelete: ImageView
        private val checkBox: CheckBox

        constructor(view: View) : super(view) {
            this.checkBox = view.findViewById(R.id.checkbox)
            this.imageViewDelete = view.findViewById(R.id.deleteImage)

            imageViewDelete.setOnClickListener {
                data.removeAt(adapterPosition)
                notifyDataSetChanged()
            }

            checkBox.setOnClickListener {
                val task = data.get(adapterPosition)
                if (task.isChecked) {
                    task.isChecked = false
                } else {
                    task.isChecked = true
                }
            }

        }

        fun bind(position: Int) {
            val taskOption = data.get(position)
            checkBox.text = taskOption.description
            checkBox.isChecked = taskOption.isChecked
        }
    }

}