package cz.uhk.pavolpodstreleny.schoolproject.screens.admin.topic

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.Action
import cz.uhk.pavolpodstreleny.schoolproject.model.Topic

/**
 * Created by pavol.podstreleny on 10.01.2018.
 */
class TopicAdminAdapter : RecyclerView.Adapter<TopicAdminAdapter.BasicViewHolder> {

    var data: List<Topic>? = null
    var listener: OnClickAdminTopicListener

    constructor(listener: OnClickAdminTopicListener) {
        this.listener = listener
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_category_admin, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: ArrayList<Topic>?) {
        this.data = data
        notifyDataSetChanged()
    }

    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val imageViewEdit: ImageView
        private val imageViewDelete: ImageView
        private val textView: TextView

        constructor(view: View) : super(view) {
            this.textView = view.findViewById(R.id.defaultText)
            this.imageViewEdit = view.findViewById(R.id.editImage)
            this.imageViewDelete = view.findViewById(R.id.deleteImage)

            imageViewEdit.setOnClickListener {
                val topic = data?.get(adapterPosition)
                if (topic != null) {
                    listener.onClick(topic, Action.EDIT)
                }
            }

            imageViewDelete.setOnClickListener {
                val topic = data?.get(adapterPosition)
                if (topic != null) {
                    listener.onClick(topic, Action.DELETE)
                }
            }

        }

        fun bind(position: Int) {
            val topic = data?.get(position)
            if (topic != null) {
                textView.text = topic.description
            }
        }
    }

    interface OnClickAdminTopicListener {
        fun onClick(topic: Topic, action: Action)
    }
}
