package cz.uhk.pavolpodstreleny.schoolproject.screens.explore

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.bumptech.glide.Glide
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.Category

/**
 * Created by pavol.podstreleny on 07.01.2018.
 */
class CategoryAdapter : RecyclerView.Adapter<CategoryAdapter.BasicViewHolder> {

    var data: List<Category>? = null
    var context: Context?
    var listener: OnCategoryClickListener


    constructor(context: Context?, listener: OnCategoryClickListener) {
        this.context = context
        this.listener = listener
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_category, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: ArrayList<Category>) {
        this.data = data
        notifyDataSetChanged()
    }

    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val imageView: ImageView
        private val textView: TextView
        private val parent: LinearLayout

        constructor(view: View) : super(view) {
            this.imageView = view.findViewById(R.id.categoryImage)
            this.textView = view.findViewById(R.id.categoryText)
            this.parent = view.findViewById(R.id.categoryParent)
            parent.setOnClickListener {
                val category = data?.get(adapterPosition)
                listener.onClick(category)
            }
        }

        fun bind(position: Int) {
            val category = data?.get(position)
            if (category != null && context != null) {
                textView.text = category.description
                Glide.with(context!!).load(category.photoURL).into(imageView)
            }
        }
    }

    interface OnCategoryClickListener {
        fun onClick(category: Category?)
    }
}