package cz.uhk.pavolpodstreleny.schoolproject.screens.explore

import android.arch.lifecycle.LiveData
import android.arch.lifecycle.ViewModel
import android.net.Uri
import cz.uhk.pavolpodstreleny.schoolproject.data.FirebaseResult
import cz.uhk.pavolpodstreleny.schoolproject.data.repositories.CategoryRepository
import cz.uhk.pavolpodstreleny.schoolproject.model.Category
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.SingleLiveEvent

/**
 * Created by pavol.podstreleny on 07.01.2018.
 */
class CategoryViewModel : ViewModel() {


    private var categories: LiveData<ArrayList<Category>>? = null
    private var spinnerCategories: SingleLiveEvent<List<Category>>? = null

    private val mCategoryRepository = CategoryRepository()


    fun getAllSpinnerCategories(): SingleLiveEvent<List<Category>> {
        if (spinnerCategories == null) {
            spinnerCategories = mCategoryRepository.getAllCategoriesForSpinner()
        }
        return spinnerCategories!!
    }

    fun getAllCategories(): LiveData<ArrayList<Category>> {
        if (categories == null) {
            categories = mCategoryRepository.getAllCategories()
        }
        return categories!!
    }

    fun isUserAdmin(): LiveData<Boolean>? {
        return mCategoryRepository.isUserAdmin()
    }

    suspend fun addCategory(uriImagePath: Uri, categoryName: String): FirebaseResult {
        return mCategoryRepository.addCategory(uriImagePath, categoryName)
    }

    suspend fun deleteCategory(urlCategory: String, imageName: String): FirebaseResult {
        return mCategoryRepository.deleteCategory(urlCategory, imageName)
    }

    suspend fun editCategory(isImageChanged: Boolean, imageUri: Uri?, oldUri: String, categoryName: String, categoryPath: String): FirebaseResult {
        return mCategoryRepository.editCategory(isImageChanged, imageUri, oldUri, categoryName, categoryPath)
    }

}