package cz.uhk.pavolpodstreleny.schoolproject.screens.groups

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.Group

/**
 * Created by pavol.podstreleny on 10.02.2018.
 */
class GroupAdapter : RecyclerView.Adapter<GroupAdapter.BasicViewHolder> {

    private var data: ArrayList<Group>? = null
    private var listener: OnClickGroupListener

    constructor(listener: OnClickGroupListener) {
        this.listener = listener
    }

    fun swapData(data: ArrayList<Group>?) {
        this.data = data
        notifyDataSetChanged()
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_group, parent, false)
        return BasicViewHolder(view)
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }


    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private var mTextView: TextView
        private var layout: LinearLayout

        constructor(view: View) : super(view) {
            mTextView = view.findViewById(R.id.textGeneral)
            layout = view.findViewById(R.id.layoutGeneral)
            layout.setOnClickListener {
                val group = data?.get(adapterPosition)
                if (group != null) {
                    listener.onClick(group)
                }
            }
        }

        fun bind(position: Int) {
            val group = data?.get(position)
            if (group != null) {
                mTextView.text = group.description
            }
        }
    }

    interface OnClickGroupListener {
        fun onClick(data: Group)
    }
}