package cz.uhk.pavolpodstreleny.schoolproject.screens.leaderboard

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.UserProfile

/**
 * Created by pavol.podstreleny on 06.01.2018.
 */
class LeaderboardAdapter : RecyclerView.Adapter<LeaderboardAdapter.LeaderboardViewHolder> {

    var data: List<UserProfile>? = null
    var listener: LeaderBoardListener


    constructor(listener: LeaderBoardListener) {
        this.listener = listener
    }


    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): LeaderboardViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_leaderboard, parent, false)
        return LeaderboardViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: LeaderboardViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: List<UserProfile>) {
        this.data = data.asReversed()
        notifyDataSetChanged()
    }

    inner class LeaderboardViewHolder : RecyclerView.ViewHolder {

        private val number: TextView
        private val name: TextView
        private val scoreTextView: TextView
        private val layoutView: LinearLayout

        constructor(view: View) : super(view) {
            this.number = view.findViewById(R.id.numberStatus)
            this.name = view.findViewById(R.id.nameOfUser)
            this.scoreTextView = view.findViewById(R.id.score)
            this.layoutView = view.findViewById(R.id.layout)

            layoutView.setOnClickListener {
                val actualUserUID = data?.get(adapterPosition)?.uid
                if (actualUserUID != null) {
                    listener.onClickItem(actualUserUID)
                }
            }
        }

        fun bind(position: Int) {
            number.text = (position + 1).toString()
            name.text = data?.get(position)?.name
            scoreTextView.text = data?.get(position)?.score.toString()
        }
    }

    interface LeaderBoardListener {
        fun onClickItem(userUID: String)
    }
}