package cz.uhk.pavolpodstreleny.schoolproject.screens.leaderboard

import android.arch.lifecycle.Observer
import android.arch.lifecycle.ViewModelProviders
import android.content.Intent
import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v7.widget.LinearLayoutManager
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.ExtraIntents
import cz.uhk.pavolpodstreleny.schoolproject.model.UserProfile
import cz.uhk.pavolpodstreleny.schoolproject.screens.user_detail.UserDetailActivity
import cz.uhk.pavolpodstreleny.schoolproject.screens.user_profile.UserProfileViewModel
import kotlinx.android.synthetic.main.fragment_leaderboard.*

/**
 * Created by pavol.podstreleny on 22.12.2017.
 */
class LeaderboardFragment : Fragment(), LeaderboardAdapter.LeaderBoardListener {

    var mAdapter: LeaderboardAdapter? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        val view = inflater?.inflate(R.layout.fragment_leaderboard, container, false)
        return view
    }

    override fun onActivityCreated(savedInstanceState: Bundle?) {
        super.onActivityCreated(savedInstanceState)

        mAdapter = LeaderboardAdapter(this)
        leaderboardRecyclerView.adapter = mAdapter
        leaderboardRecyclerView.layoutManager = LinearLayoutManager(this.context)

        val viewModel = ViewModelProviders.of(this).get(UserProfileViewModel::class.java)

        viewModel.getAllUsers().observe(this, Observer { datas ->
            updateUsers(datas)
        })
    }

    private fun updateUsers(data: ArrayList<UserProfile>?) {
        if (data != null && data.size > 0) {
            hideProgress()
            mAdapter?.swapData(data)
        } else {
            showProgress()
        }
    }

    private fun hideProgress() {
        pbLeaderBoard.visibility = View.GONE
        leaderboardLayout.visibility = View.VISIBLE
    }

    private fun showProgress() {
        pbLeaderBoard.visibility = View.VISIBLE
        leaderboardLayout.visibility = View.GONE
    }

    override fun onClickItem(userUID: String) {
        val intent = Intent(activity, UserDetailActivity::class.java)
        intent.putExtra(ExtraIntents.USER_ID, userUID)
        startActivity(intent)
    }
}