package cz.uhk.pavolpodstreleny.schoolproject.screens.result

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.ExtraIntents
import cz.uhk.pavolpodstreleny.schoolproject.receivers.ConnectionObserver
import cz.uhk.pavolpodstreleny.schoolproject.receivers.ConnectionReceiver
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.INetworkChecker
import cz.uhk.pavolpodstreleny.schoolproject.utils.roundTo2DecimalPlaces
import kotlinx.android.synthetic.main.activity_result.*
import kotlinx.android.synthetic.main.view_app_bar.*
import kotlinx.android.synthetic.main.view_no_network_connectino_small.*

/**
 * Created by pavol.podstreleny on 12.02.2018.
 */
class ResultPage : AppCompatActivity(),INetworkChecker {

    override var connectionObserver: ConnectionObserver? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_result)

        setSupportActionBar(toolbar)
        supportActionBar?.title = getString(R.string.result_page_title)

        connectionObserver = ConnectionObserver(ConnectionReceiver(noInternet),this,this)

        if(intent.extras != null){
            score.text = intent.getDoubleExtra(ExtraIntents.EXTRA_RESULT,0.0).roundTo2DecimalPlaces().toString()
        }

        profile.setOnClickListener {
            finishActivity()
        }
    }

    override fun onResume() {
        super.onResume()
        connectionObserver?.start()
    }

    override fun onBackPressed() {
        finishActivity()
    }

    private fun finishActivity(){
        val intent = Intent()
        setResult(Activity.RESULT_OK,intent)
        finish()
    }
}