package cz.uhk.pavolpodstreleny.schoolproject.screens.tasks

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.CheckBox
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.TaskOption

/**
 * Created by pavol.podstreleny on 10.02.2018.
 */

class ChooserAdapter : RecyclerView.Adapter<ChooserAdapter.BasicViewHolder>() {

    private var data: ArrayList<TaskOption>? = null

    fun swapData(data: ArrayList<TaskOption>?) {
        this.data = data
        notifyDataSetChanged()
    }

    fun getData(): ArrayList<TaskOption>? {
        return this.data
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_task, parent, false)
        return BasicViewHolder(view)
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.unCheck()
        holder?.bind(position)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private var checkBox: CheckBox

        constructor(view: View) : super(view) {
            checkBox = view.findViewById(R.id.checkbox)

            checkBox.setOnClickListener {
                val task = data?.get(adapterPosition)
                if (task != null) {
                    if (task.isChecked) {
                        task.isChecked = false
                    } else {
                        task.isChecked = true
                    }
                }
            }
        }

        fun bind(position: Int) {
            val task = data?.get(position)
            checkBox.text = task?.description
        }

        fun unCheck() {
            checkBox.isChecked = false
        }
    }

}