package cz.uhk.pavolpodstreleny.schoolproject.screens.tasks

import android.app.Dialog
import android.app.DialogFragment
import android.content.Context
import android.os.Bundle
import android.support.v7.app.AlertDialog
import cz.uhk.pavolpodstreleny.schoolproject.R

/**
 * Created by pavol.podstreleny on 10.02.2018.
 */


class TaskCancelDialog : DialogFragment() {

    var listener: OnDialogClick? = null

    interface OnDialogClick {
        fun onClickBackAccepted()
    }

    override fun onAttach(context: Context?) {
        super.onAttach(context)
        listener = context as OnDialogClick
    }

    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {
        val builder = AlertDialog.Builder(activity!!, R.style.AlertDialogCustom)
        builder.setMessage(R.string.task_page_go_back)
                .setPositiveButton(R.string.global_button_yes, { _, _ -> listener?.onClickBackAccepted() })
                .setNegativeButton(R.string.global_button_cancel, { dialog, _ -> dialog.cancel() })
                .setTitle(R.string.task_page_go_back_title)
        return builder.create()
    }
}