package cz.uhk.pavolpodstreleny.schoolproject.screens.topics

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.bumptech.glide.Glide
import com.bumptech.glide.request.RequestOptions
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.Topic

/**
 * Created by pavol.podstreleny on 09.02.2018.
 */
class TopicAdapter : RecyclerView.Adapter<TopicAdapter.BasicViewHolder> {

    var data: List<Topic>? = null
    var context: Context
    val listener: OnClickTopicListener

    constructor(context: Context, listener: OnClickTopicListener) {
        this.context = context
        this.listener = listener
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BasicViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_topic, parent, false)
        return BasicViewHolder(view)
    }

    override fun getItemCount(): Int {
        if (data == null) {
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BasicViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: ArrayList<Topic>?) {
        this.data = data
        notifyDataSetChanged()
    }

    inner class BasicViewHolder : RecyclerView.ViewHolder {

        private val layout: LinearLayout
        private val imageView: ImageView
        private val textView: TextView

        constructor(view: View) : super(view) {
            this.layout = view.findViewById(R.id.generalLayout)
            this.textView = view.findViewById(R.id.generalText)
            this.imageView = view.findViewById(R.id.generalImage)

            layout.setOnClickListener {
                listener.onClick(data?.get(adapterPosition))
            }
        }

        fun bind(position: Int) {
            val topic = data?.get(position)
            if (topic != null) {
                textView.text = topic.description
                Glide.with(context).load(topic.photoURL).apply(RequestOptions().circleCrop()).into(imageView)
            }
        }
    }

    interface OnClickTopicListener {
        fun onClick(data: Topic?)
    }

}