package cz.uhk.pavolpodstreleny.schoolproject.screens.user_detail

import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.data.ExtraIntents
import cz.uhk.pavolpodstreleny.schoolproject.receivers.ConnectionObserver
import cz.uhk.pavolpodstreleny.schoolproject.receivers.ConnectionReceiver
import cz.uhk.pavolpodstreleny.schoolproject.screens.admin.INetworkChecker
import cz.uhk.pavolpodstreleny.schoolproject.screens.user_profile.UserProfileFragment
import kotlinx.android.synthetic.main.view_app_bar.*
import kotlinx.android.synthetic.main.view_no_network_connectino_small.*

/**
 * Created by pavol.podstreleny on 22.02.2018.
 */
class UserDetailActivity : AppCompatActivity(), INetworkChecker {

    private val USER_PROFILE_FRAGMENT = "USER_PROFILE_FRAGMENT"

    override var connectionObserver: ConnectionObserver? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_user_detail)

        connectionObserver = ConnectionObserver(ConnectionReceiver(noInternet), this, this)

        toolbar.title = getString(R.string.userDetail_page_title)


        var userUID: String? = null
        val intent = getIntent()
        if (intent != null && intent.hasExtra(ExtraIntents.USER_ID)) {
            userUID = intent.getStringExtra(ExtraIntents.USER_ID)
            setSupportActionBar(toolbar)
            supportActionBar?.setDisplayHomeAsUpEnabled(true)
            toolbar.setNavigationOnClickListener {
                finish()
            }
        }

        if (userUID != null) {
            val userProfile = UserProfileFragment()
            val bundle = Bundle()
            bundle.putString(ExtraIntents.USER_ID, userUID)
            userProfile.arguments = bundle
            supportFragmentManager.beginTransaction().replace(R.id.fragmentShower, userProfile).commit()
        }


    }

    override fun onResume() {
        super.onResume()
        connectionObserver?.start()
    }

}