package cz.uhk.pavolpodstreleny.schoolproject.screens.user_profile

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import com.bumptech.glide.Glide
import cz.uhk.pavolpodstreleny.schoolproject.R
import cz.uhk.pavolpodstreleny.schoolproject.model.Badge

/**
 * Created by pavol.podstreleny on 06.01.2018.
 */
class UserBadgesAdapter : RecyclerView.Adapter<UserBadgesAdapter.BadgesViewHolder> {


    var data: List<Badge>? = null
    val context: Context?

    constructor(context: Context?){
        this.context = context
    }

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): BadgesViewHolder {
        val view = LayoutInflater.from(parent?.context).inflate(R.layout.list_item_user_badges,parent,false)
        return BadgesViewHolder(view)
    }

    override fun getItemCount(): Int {
        if(data == null){
            return 0
        }
        return data!!.size
    }

    override fun onBindViewHolder(holder: BadgesViewHolder?, position: Int) {
        holder?.bind(position)
    }

    fun swapData(data: List<Badge>){
        this.data = data
        notifyDataSetChanged()
    }

    inner class BadgesViewHolder : RecyclerView.ViewHolder{

        private val image: ImageView
        private val textView: TextView

        constructor(view: View): super(view){
            this.image = view.findViewById(R.id.badge)
            this.textView = view.findViewById(R.id.badgeText)
        }

        fun bind(position: Int){
            if(context != null){
                textView.text = data?.get(position)?.description
                Glide.with(context).load(data?.get(position)?.photoURL).into(image)
            }
        }
    }
}