package cz.uhk.pavolpodstreleny.schoolproject.screens.user_profile

import android.arch.lifecycle.LiveData
import android.arch.lifecycle.MutableLiveData
import android.arch.lifecycle.Transformations
import android.arch.lifecycle.ViewModel
import cz.uhk.pavolpodstreleny.schoolproject.data.FirebaseResult
import cz.uhk.pavolpodstreleny.schoolproject.data.repositories.UserRepository
import cz.uhk.pavolpodstreleny.schoolproject.model.Badge
import cz.uhk.pavolpodstreleny.schoolproject.model.UserProfile


/**
 * Created by pavol.podstreleny on 23.12.2017.
 */
class UserProfileViewModel : ViewModel {

    private val mUserRepository: UserRepository

    var userIDBadges: MutableLiveData<String> = MutableLiveData()
    val badges: LiveData<ArrayList<Badge>> = Transformations.switchMap(userIDBadges,{
        id-> getUserBadges(id)}
    )

    constructor(){
        mUserRepository = UserRepository()
    }

    fun getCurrentUser(childUID: String): LiveData<UserProfile>{
        return mUserRepository.getUser(childUID)
    }

    fun getUserBadges(userUID: String): LiveData<ArrayList<Badge>>{
        return mUserRepository.getBadges(userUID)
    }

    fun getAllUsers(): LiveData<ArrayList<UserProfile>>{
        return mUserRepository.getAllUsers()
    }

    suspend fun changeUserName(newUserName: String): FirebaseResult{
        return mUserRepository.changeUserName(newUserName)
    }

}